use std::fmt;

use serde::{Deserialize, Serialize};

//#[derive(Debug, Clone, Serialize, Deserialize)]
//pub struct Image {
//	pub filename: String,
//	pub img: Box<[u8]>,
//}

#[derive(Debug, Clone, Serialize, Deserialize)]
pub struct Post {
	pub id: u32, // technically reduntant but whatever
	pub img: Option<Vec<u8>>,
	pub body: String,
}

#[derive(Debug, Clone, Serialize, Deserialize)]
pub struct Thread(Vec<u32>);

impl IntoIterator for Thread {
	type Item = u32;
	type IntoIter = std::vec::IntoIter<Self::Item>;

	fn into_iter(self) -> Self::IntoIter {
		self.0.into_iter()
	}
}

impl Thread {
	pub fn new(op: u32) -> Self {
		Thread(vec![op])
	}
	pub fn push(&mut self, thing: u32) {
		self.0.push(thing)
	}
}

impl Post {
	pub fn new(id: u32, body: String) -> Self {
		Self {
			id,
			img: None,
			body,
		}
	}
}

// TODO move this to `www/`
impl fmt::Display for Post {
	fn fmt(&self, f: &mut fmt::Formatter<'_>) -> fmt::Result {
		write!(
			f,
			"<article>\
				<img src=\"{}/img\" alt=\"img\">\
				<div>\
					<div class=\"meta\">\
						<div>\
							{}&nbsp;\
							<strong>{}</strong>&nbsp;\
						</div>\
						<nav>\
							<a href=\"{}\">open</a>\
							<a href=\"#\">quote</a>\
							<a href=\"#\">reply</a>\
						</nav>\
					</div>\
					<div class=\"image-info\">{}</div>\
					{}\
				</div>\
			</article>",
			self.id,
			"",
			self.id,
			self.id,
			//if let Some(s) = &self.img {
			//	&s.filename
			//} else {
			//	""
			//},
			"",
			self.body,
		)
	}
}
